# -*- coding: UTF-8 -*-
from Poll import Poll
from Components.Converter.Converter import Converter
from enigma import iServiceInformation, iPlayableService
from Components.Element import cached
import os


def addspace(text):
	if text:
		text += " "
	return text

class SDInfo(Poll, Converter, object):

	Resolution = 1
	VideoCodec = 2       	
	
	
	def __init__(self, type):
		Converter.__init__(self, type)
		Poll.__init__(self)
		self.type, self.interesting_events = {
				"Resolution": (self.Resolution, (iPlayableService.evUpdatedInfo,)),								
                "VideoCodec": (self.VideoCodec, (iPlayableService.evUpdatedInfo,)),
				
 			}[type]
		self.poll_interval = 1000
		self.poll_enabled = True


	def createVideoCodec(self, info):
		return codec_data.get(info.getInfo(iServiceInformation.sVideoType), "N/A")
		
	def getServiceInfoString(self, info, what, convert = lambda x: "%d" % x):
		v = info.getInfo(what)
		if v == -1:
			return "N/A"
		if v == -2:
			return info.getInfoString(what)
		# v == -3 now use only for caids
		# i don't know how it work with another parametrs
		# now i made for returning values as hex string separated by space
		# may be better use convert for formating output but it TBA 
		if v == -3:
			t_objs = info.getInfoObject(what)
			if t_objs and (len(t_objs) > 0):
				ret_val=""
				for t_obj in t_objs:
					ret_val += "%.4X " % t_obj
				return ret_val[:-1]
			else:
				return ""
		return convert(v)

	@cached
	def getText(self):
		service = self.source.service
		info = service and service.info()
		if not info:
			return ""
                if self.type == self.Resolution:
                        xres = info.getInfo(iServiceInformation.sVideoWidth)
                        if xres == -1:
                                return " "
                        yres = info.getInfo(iServiceInformation.sVideoHeight)
                        mode = ('i', 'p', ' ')[info.getInfo(iServiceInformation.sProgressive)]
                        fps = str((info.getInfo(iServiceInformation.sFrameRate) + 500) / 1000)
                        return str(xres) + 'x' + str(yres) + mode + fps
		

	text = property(getText)
	
					
	def changed(self, what):
		if what[0] == self.CHANGED_SPECIFIC:
			if what[1] == iPlayableService.evStart or what[1] == iPlayableService.evVideoSizeChanged or what[1] == iPlayableService.evUpdatedInfo:
				Converter.changed(self, what)
		elif what[0] != self.CHANGED_SPECIFIC or what[1] in self.interesting_events:
			Converter.changed(self, what)
		elif what[0] == self.CHANGED_POLL:
			self.downstream_elements.changed(what)
